﻿Public Class Form1

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim printset As New FarPoint.Win.Spread.PrintInfo()
        printset.PrintToPdf = True
        printset.PdfFileName = "ResultedPDF.pdf"
        printset.Opacity = 10
        'Assign the printer settings and print
        FpSpread1.Sheets(0).PrintInfo = printset
        FpSpread1.PrintSheet(0)
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        FpSpread1.Sheets(0).Cells(5, 5).Value = 30
        FpSpread1.Sheets(0).Cells(1, 1).Value = 15
        FpSpread1.Sheets(0).Cells(2, 1).Value = 100
        FpSpread1.BackgroundImage = PictureBox1.Image
        FpSpread1.ActiveSheet.DefaultStyle.BackColor = Color.Transparent
    End Sub

    Private Sub FpSpread1_PrintBackground(sender As Object, e As FarPoint.Win.Spread.PrintBackgroundEventArgs) Handles FpSpread1.PrintBackground
        Dim saveState As Drawing2D.GraphicsState = e.Graphics.Save
        Dim rect As Rectangle = e.SheetRectangle
        rect.Width = AdjustWorkaroundForPDFPrint(rect.Width)
        rect.Height = AdjustWorkaroundForPDFPrint(rect.Height)
        e.Graphics.SetClip(rect)
        e.Graphics.DrawImage(FpSpread1.BackgroundImage, rect)
        e.Graphics.Restore(saveState)
    End Sub

    Private Function AdjustWorkaroundForPDFPrint(ByRef value As Single) As Single
        Dim _ptperInch As Integer = 72 'Points Per inch						
        Dim pixelPointFactor As Single = _ptperInch / 96 'pixel point factor base on graphic dpi
        Dim displayPointFactor As Single = _ptperInch / 100 'point factor base on display graphic unit
        Return (value * displayPointFactor / pixelPointFactor)
    End Function

    Private Sub FpSpread1_PrintMessageBox(sender As Object, e As FarPoint.Win.Spread.PrintMessageBoxEventArgs) Handles FpSpread1.PrintMessageBox
        If e.BeginPrinting Then
            FpSpread1.ActiveSheet.DefaultStyle.ResetBackColor()
        Else
            FpSpread1.ActiveSheet.DefaultStyle.BackColor = Color.Transparent
        End If
    End Sub
End Class
